#ifndef TREE_NODE_HPP_
#define TREE_NODE_HPP_

#include <stdexcept>
#include <utility>

template<typename T>
struct TreeNode
{
  TreeNode* parent;
  TreeNode* left;
  TreeNode* right;
  T data;

  constexpr TreeNode () noexcept = default;

  constexpr TreeNode (T const& v, TreeNode* p, TreeNode* l,
                      TreeNode* r) noexcept
  /* TODO -- initialize each member using the member initializer list */
  {
  }

  constexpr TreeNode (T&& v, TreeNode* p, TreeNode* l, TreeNode* r) noexcept
    : parent (p), left (l), right (r), data (std::move (v))
  {
  }

  constexpr TreeNode (T const& v) noexcept
    : TreeNode (v, nullptr, nullptr, nullptr)
  {
  }

  constexpr TreeNode (T&& v) noexcept
    : TreeNode (std::move (v), nullptr, nullptr, nullptr)
  {
  }

  constexpr TreeNode (TreeNode const&) noexcept
  /* TODO -- intialize each member using the member initialized list */
  {
  }

  constexpr TreeNode (TreeNode&&) noexcept = default;

  constexpr TreeNode&
  operator= (TreeNode const&) noexcept = default;

  constexpr TreeNode&
  operator= (TreeNode&&) noexcept = default;
};

namespace TreeNodeUtils
{

template<typename T>
constexpr bool
isRoot (TreeNode<T>* n) noexcept
{
  // TODO -- determine that n is the root of the tree
  // hint: the header's parent is the root. What's the relationship
  //       between the parent and the header?
  return false;
}

template<typename T>
constexpr bool
isLeaf (TreeNode<T>* n) noexcept
{
  // TODO -- determine that n is a leaf
  return false;
}

template<typename T>
constexpr bool
isLeftChild (TreeNode<T>* n) noexcept
{
  // TODO -- determine that n is a left child
  // note: it is not a left child if it's the root
  return false;
}

template<typename T>
constexpr bool
isRightChild (TreeNode<T>* n) noexcept
{
  // TODO -- determine that n is a right child
  // note: it is not a right child if it's the root
  return false;
}

// helper that takes a pointer to a node and magically gets
// the appropriate reference to the node
template<typename T>
constexpr TreeNode<T>*&
referenceOf (TreeNode<T>* node) noexcept
{
  if (isRoot (node))
  {
    return node->parent->parent;
  }
  else if (isLeftChild (node))
  {
    return node->parent->left;
  }
  else if (isRightChild (node))
  {
    return node->parent->right;
  }
  else
  {
    throw std::runtime_error{"unknown state of node"};
  }
}

// returns the minimum node rooted at "n"
template<typename T>
constexpr TreeNode<T>*
minimum (TreeNode<T>* n) noexcept
{
  // TODO
  return nullptr;
}

// returns the maximum node rooted at "n"
template<typename T>
constexpr TreeNode<T>*
maximum (TreeNode<T>* n) noexcept
{
  // TODO
  return nullptr;
}

// returns the in-order successor of "n"
template<typename T>
constexpr TreeNode<T>*
successor (TreeNode<T>* n) noexcept
{
  // TODO
  return nullptr;
}

// returns the in-order predecessor of "n"
template<typename T>
constexpr TreeNode<T>*
predecessor (TreeNode<T>* n) noexcept
{
  // TODO
  return nullptr;
}

// "clones" a tree rooted at n. uses parent parameter to set
// the copied tree's parent. Hint: create a new node, then
// set parent, left, and right. left and right should be set
// through recursive calls to copy
template<typename T>
TreeNode<T>*
copy (TreeNode<T>* n, TreeNode<T>* parent)
{
  // TODO
  return nullptr;
}

// clears a tree rooted at "n". delete should be called for
// each node in the tree. Remember: once we delete we can no
// longer "read" any information from the node.
//   Note: should set n to nullptr after deleting
template<typename T>
void
clear (TreeNode<T>*& n) noexcept
{
  // TODO
}

} // end namespace TreeNodeUtils

#endif
